﻿
' (C) Copyright 2002-2005 by Autodesk, Inc. 
'
' Permission to use, copy, modify, and distribute this software in
' object code form for any purpose and without fee is hereby granted, 
' provided that the above copyright notice appears in all copies and 
' that both that copyright notice and the limited warranty and
' restricted rights notice below appear in all supporting 
' documentation.
'
' AUTODESK PROVIDES THIS PROGRAM "AS IS" AND WITH ALL FAULTS. 
' AUTODESK SPECIFICALLY DISCLAIMS ANY IMPLIED WARRANTY OF
' MERCHANTABILITY OR FITNESS FOR A PARTICULAR USE.  AUTODESK, INC. 
' DOES NOT WARRANT THAT THE OPERATION OF THE PROGRAM WILL BE
' UNINTERRUPTED OR ERROR FREE.
'
' Use, duplication, or disclosure by the U.S. Government is subject to 
' restrictions set forth in FAR 52.227-19 (Commercial Computer
' Software - Restricted Rights) and DFAR 252.227-7013(c)(1)(ii)
' (Rights in Technical Data and Computer Software), as applicable.
'
'VB.NET
Imports Autodesk.AutoCAD.Runtime

Imports Autodesk.AutoCAD.DatabaseServices
Imports Autodesk.AutoCAD.Geometry
Imports Autodesk.AutoCAD.Colors

Imports Autodesk.AutoCAD.EditorInput
Imports Autodesk.AutoCAD.ApplicationServices

Imports Autodesk.AutoCAD.Windows

Imports System.Runtime.InteropServices 'for DllImport()

Imports System.Text ' for StringBuilder

<Assembly: ExtensionApplication(GetType(AsdkClass1))> 
Public Class AsdkClass1
    Implements IExtensionApplication

    Overridable Sub Initialize() Implements IExtensionApplication.Initialize
    End Sub

    Overridable Sub Terminate() Implements IExtensionApplication.Terminate
    End Sub


    ' Use P/Invoke for acedGetSym
    <DllImport("acad.exe", CharSet:=CharSet.Unicode, _
           CallingConvention:=CallingConvention.Cdecl, EntryPoint:="acedGetSym")> _
    Shared Function acedGetSym(ByVal args As String, <Out()> ByRef result As IntPtr) As Integer
    End Function

    ' Use P/Invoke for acedPutSym
    <DllImport("acad.exe", CharSet:=CharSet.Unicode, CallingConvention:=CallingConvention.Cdecl, EntryPoint:="acedPutSym")> _
    Shared Function acedPutSym(ByVal args As String, ByVal result As IntPtr) As Integer
    End Function

    'use P/Invoke for acedInvoke
    <DllImport("acad.exe", CallingConvention:=CallingConvention.Cdecl, EntryPoint:="acedInvoke")> _
    Private Shared Function acedInvoke(ByVal args As IntPtr, ByRef result As IntPtr) As Integer
    End Function








    '<LispFunction("Helloworld")> _
    'Public Function dNetLispDemo01(ByVal myLispArgs As ResultBuffer) As ResultBuffer
    '    'Shows to how to use the LispFunction and communicate with lisp from .NET
    '    Dim ed As Editor
    '    'send a messgae to AutoCAD command line
    '    ed = Autodesk.AutoCAD.ApplicationServices.Application.DocumentManager.MdiActiveDocument.Editor
    '    ed.WriteMessage("Hello World from .NET function" & vbLf)

    '    Return myLispArgs

    'End Function










    <LispFunction("getArg")> _
    Public Function dNetLispDemo02(ByVal myLispArgs As ResultBuffer) As ResultBuffer
        'Shows to how to use the LispFunction and communicate with lisp from .NET
        Dim ed As Editor
        'Get editor
        ed = Autodesk.AutoCAD.ApplicationServices.Application.DocumentManager.MdiActiveDocument.Editor

        'Ensure arguments have been passed in 
        If myLispArgs Is Nothing Then
            ' Write a message on the AutoCAD command line
            ed.WriteMessage("No Arguments passed in" & vbLf)

        Else
            ' Get the arguments passed by the lisp function
            Dim myArgsArray As Array
            myArgsArray = myLispArgs.AsArray

            ' Get the TypedValue at element zero in the array
            Dim oTypeVal As TypedValue
            oTypeVal = myArgsArray.GetValue(0)
            'Write the type to the AutoCAD command line
            ed.WriteMessage("TypeCode of argument = " + oTypeVal.TypeCode.ToString() & vbLf)
            'Write the value to the AutoCAD command line
            ed.WriteMessage("Value of argument = " + oTypeVal.Value.ToString() & vbLf)

        End If
        Return myLispArgs
    End Function














    'Use this lisp code to test changeArgs, 
    ' or just enter (changeArgs 10 20 30) on the command ine
    '(defun c:changeArgs (dToChange / myDoubles d1 str str2)
    ' (setq myDoubles(changeArgs 20 dToChange 30)); send the arguments to .NET
    ' (Setq d1(nth 0 myDoubles));get the first argument returned
    ' (setq str(strcat ".NET changed " (rtos dToChange)))
    ' (setq str2(strcat " to " (rtos d1)))
    ' (princ (strcat str str2))	
    ' (princ)
    ' )
    <LispFunction("changeArgs")> _
    Public Function dNetLispDemo02a(ByVal myLispArgs As ResultBuffer) As ResultBuffer
        ' Shows how to get arguments passed into a lisp function
        ' change them and send arguments back
        Dim ed As Editor
        ed = Autodesk.AutoCAD.ApplicationServices.Application.DocumentManager.MdiActiveDocument.Editor

        'Ensure there are arguments passed in
        If myLispArgs Is Nothing Then
            ed.WriteMessage("No arguments" & vbLf)
            Return myLispArgs
        Else

            Dim myArgsArray As Array
            myArgsArray = myLispArgs.AsArray
            'Ensure there are at least 3 arguments
            If myArgsArray.Length > 2 Then

                Dim myArg1, myArg2, myArg3 As Double

                'Get the arguments that were passed in
                Dim myTypeVal As TypedValue
                myTypeVal = myArgsArray.GetValue(0)
                myArg1 = myTypeVal.Value
                ' does the same thing as the previous two lines gets Arguments 2 and 3
                myArg2 = CType(myArgsArray.GetValue(1), TypedValue).Value
                myArg3 = CType(myArgsArray.GetValue(2), TypedValue).Value

                ' Add the arguments to make a change 
                myArg1 = myArg1 + myArg2
                myArg2 = myArg2 + myArg3
                myArg3 = myArg3 + myArg1

                ' Package data to send back to calling lisp function
                Dim rbfResult As ResultBuffer
                rbfResult = New ResultBuffer( _
                                New TypedValue(CInt(LispDataType.Double), myArg1), _
                                New TypedValue(CInt(LispDataType.Double), myArg2), _
                                New TypedValue(CInt(LispDataType.Double), myArg3))

                ed.WriteMessage("Updated arguments in .NET function" & vbLf)

                Return rbfResult
            Else
                ed.WriteMessage("Not enough arguments" & vbLf)
                Return myLispArgs
            End If
        End If

        Return myLispArgs

    End Function
    ' This example can be used with the getId function
    '    (defun c:getId ( / id obj )
    '    (vl-load-com)
    '    (setq id   (getId)
    '	 obj (vlax-ename->vla-object (nth 0 id))
    '	 )
    '    (vla-highlight obj :vlax-true) 	
    '    )



    <LispFunction("getId")> _
    Public Function dNetLispDemo02b(ByVal myLispArgs As ResultBuffer) As ResultBuffer
        ' This example asks the user to select an entity
        ' The object id of the entity is returned to the calling lisp function
        Dim rbfResult As ResultBuffer
        Dim ed As Autodesk.AutoCAD.EditorInput.Editor
        ed = Autodesk.AutoCAD.ApplicationServices.Application.DocumentManager.MdiActiveDocument.Editor

        Dim prmptEntOpts As New PromptEntityOptions("Select Entity")
        Dim prmptEntRes As PromptEntityResult

        ' Get the entity from the users selection
        prmptEntRes = ed.GetEntity(prmptEntOpts)

        ' Make sure the entity was selected ok
        If prmptEntRes.Status <> PromptStatus.OK Then
            rbfResult = New ResultBuffer(New TypedValue(LispDataType.Nil))
            Return rbfResult
        End If

        ' Return the ObjectId to the Lisp function
        Dim objId As ObjectId
        objId = prmptEntRes.ObjectId
        rbfResult = New ResultBuffer(New TypedValue(LispDataType.ObjectId, objId))

        Return rbfResult

    End Function



    <LispFunction("getSelSet")> _
    Public Function dNetLispDemo02c(ByVal myLispArgs As ResultBuffer) As ResultBuffer
        ' This example prompts the user for a selecton set of entities
        ' it passes the selection set back to the calling lisp function
        Dim rbfResult As ResultBuffer
        Dim ed As Autodesk.AutoCAD.EditorInput.Editor
        ed = Autodesk.AutoCAD.ApplicationServices.Application.DocumentManager.MdiActiveDocument.Editor

        Dim prmptSelOpts As New PromptSelectionOptions()
        Dim prmptSelRes As PromptSelectionResult

        prmptSelRes = ed.GetSelection(prmptSelOpts)
        ' Ensure the selection set ok
        If prmptSelRes.Status <> PromptStatus.OK Then
            'Return nil to calling lisp function
            rbfResult = New ResultBuffer(New TypedValue(LispDataType.Nil))
            Return rbfResult
        End If

        'Create Resbuf conataining the selection set
        Dim selSet As SelectionSet
        selSet = prmptSelRes.Value
        rbfResult = New ResultBuffer( _
                    New TypedValue(CInt(LispDataType.SelectionSet), selSet))

        ed.WriteMessage("Returning selection set" & vbLf)
        ' Send the ResultBuffer with the selection set to the calling lisp function
        Return rbfResult

    End Function

    <LispFunction("dNetGpath")> _
    Public Function VBNetFunction(ByVal myLispArgs As ResultBuffer) As ResultBuffer
        'This example displays a .NET form gets values from the user and then 
        ' sends those values back to the calling lisp function. This is intended to 
        ' work with an update to the Visual Lisp tutorial that ships with AutoCAD

        ' Show the form
        Dim gPathFrm As New GardenPath
        gPathFrm.ShowDialog()

        ' Need a ResultBuffer to send back to the calling lisp function
        Dim rbfResult As ResultBuffer

        ' User clicked ok on the form
        If gPathFrm.bOK = True Then

            ' Get the radius of tile to use from the form
            Dim dRadOfTile As Double
            dRadOfTile = gPathFrm.tb_RadiusOfTile.Text

            ' Bet the spacing of tiles to use
            Dim dSpaceOfTiles As Double
            dSpaceOfTiles = gPathFrm.tb_SpacingBetweenTiles.Text

            ' Get the creation type
            Dim strCreationType As String
            If gPathFrm.rb_ActiveX.Checked Then
                strCreationType = "ActiveX"
            ElseIf gPathFrm.rb_Entmake.Checked Then
                strCreationType = "Entmake"
            Else
                strCreationType = "Command"
            End If

            Dim strPlineType As String
            If gPathFrm.rb_Lightweight.Checked Then
                strPlineType = "Light"
            Else
                strPlineType = "Heavy"
            End If


            ' Package up values to send to lisp function            
            rbfResult = New ResultBuffer( _
                            New TypedValue(CInt(LispDataType.Double), dRadOfTile), _
                            New TypedValue(CInt(LispDataType.Double), dSpaceOfTiles), _
                            New TypedValue(CInt(LispDataType.Text), strCreationType), _
                            New TypedValue(CInt(LispDataType.Text), strPlineType))
            'Return values to lisp function
            Return rbfResult

        End If

        'there was an error so return nil 
        rbfResult = New ResultBuffer(New TypedValue(CInt(LispDataType.Nil)))
        Return rbfResult
    End Function

    Public Shared Function AcadGetSym(ByVal varname As String) As ResultBuffer ', ByRef stat As Integer) As ResultBuffer
        ' IntPtr is an integer (used as a pointer for .NET) initialize to zero
        Dim rb As IntPtr = IntPtr.Zero
        ' use the function that was p/Invoked, pass in the name that was 
        ' provided by the user and the IntPtr
        Dim stat As Integer = 0
        stat = acedGetSym(varname, rb)

        ' If stat is ok and the IntPtr is not zero create a ResultBuffer and Return it
        If stat = CType(PromptStatus.OK, Integer) AndAlso Not (rb = IntPtr.Zero) Then
            Return CType(DisposableWrapper.Create(GetType(ResultBuffer), rb, True), ResultBuffer)
        End If

        ' Getting the symbol failed if we reach this return statement
        Return Nothing
    End Function

    'Public Shared Function AcadPutSym(ByVal varname As String, ByVal rb As ResultBuffer) As Integer
    '    Return acedPutSym(varname, rb.UnmanagedObject)
    'End Function

    <CommandMethod("GetSym")> _
    Public Shared Sub GetSym()
        ' Get the name of the symbol from the user
        Dim ed As Editor = Autodesk.AutoCAD.ApplicationServices.Application.DocumentManager.MdiActiveDocument.Editor

        Dim res As PromptResult = ed.GetString("" & Microsoft.VisualBasic.Chr(10) & "Name of LISP-Symbol: ")
        If res.Status = PromptStatus.OK Then
            ' Populate a ResultBuffer with the values of the symbol by calling
            ' local function AcadGetSym which uses acedGetSym that was called through
            ' P/Invoke
            Dim ResBuf As ResultBuffer = AcadGetSym(res.StringResult)

            ' Ensure that ResultBuffer it is not nothing
            If Not (ResBuf Is Nothing) Then
                Dim s As StringBuilder = New StringBuilder
                s.Append("" & Microsoft.VisualBasic.Chr(10) & "-----------------------------")
                ' Append each type and value in the symbol
                For Each val As TypedValue In CType(ResBuf, IEnumerable)
                    s.AppendFormat("" & Microsoft.VisualBasic.Chr(10) & "{0} -> {1}", val.TypeCode, val.Value.ToString)
                Next
                s.Append("" & Microsoft.VisualBasic.Chr(10) & "-----------------------------")
                ' Write the types and values from the ResultBuffer to the AutoCAD command line 
                ed.WriteMessage(s.ToString)
            End If
        End If
    End Sub

    <CommandMethod("PutSym")> _
    Public Shared Sub PutSym()
        ' Get the editor and prompt for symbol name
        Dim ed As Editor = Autodesk.AutoCAD.ApplicationServices.Application.DocumentManager.MdiActiveDocument.Editor
        Dim res As PromptResult = ed.GetString("" & Microsoft.VisualBasic.Chr(10) & "Name of LISP-Symbol: ")
        If res.Status = PromptStatus.OK Then
            ' Change the value of the LISP Symbol to myNETSymbol
            Dim ResBuf As ResultBuffer = New ResultBuffer
            ResBuf.Add(New TypedValue(LispDataType.Text, "myNETSymbol"))
            Dim stat As Integer
            'stat = AcadPutSym(res.StringResult, ResBuf) 'AcadPutSym is a local function
            ' call acedPutSym that was p/Invoked, pass the value entered by the user
            ' and the ResultBuffer Unmanaged Object
            stat = acedPutSym(res.StringResult, ResBuf.UnmanagedObject) 'rb.UnmanagedObject)
            If stat <> PromptStatus.OK Then
                ed.WriteMessage("" & Microsoft.VisualBasic.Chr(10) & "Error using acedPutSym ")
            End If
        End If
    End Sub


    <LispFunction("testInvoke")> _
    Public Function TestAcedInvoke(ByVal myLispArgs As ResultBuffer) As ResultBuffer

        MsgBox("test1")

        Dim ed As Editor = Autodesk.AutoCAD.ApplicationServices.Application.DocumentManager.MdiActiveDocument.Editor
        If myLispArgs Is Nothing Then
            ' Write a message on the AutoCAD command line
            ed.WriteMessage("No Arguments passed in" & vbLf)
            Return myLispArgs
        Else

            Dim myArray As Array = myLispArgs.AsArray
            Dim myTypedVal As TypedValue = myArray(0)

            Dim resBuf As New Autodesk.AutoCAD.DatabaseServices.ResultBuffer()
            resBuf.Add(New TypedValue(LispDataType.Text, "c:myFunction")) 'name of the function
            resBuf.Add(New TypedValue(LispDataType.ListBegin, -1)) '" begin a list
            resBuf.Add(New TypedValue(LispDataType.Text, "Some TEXT added in VB function")) 'a double parameter
            resBuf.Add(New TypedValue(LispDataType.Text, myTypedVal.Value)) ' value passed in
            resBuf.Add(New TypedValue(LispDataType.Double, 20.2)) 'a double parameter
            resBuf.Add(New TypedValue(LispDataType.ListEnd, -1)) 'end of the list 

            Dim intPtr1 As IntPtr = IntPtr.Zero

            Dim intStat As Integer = acedInvoke(resBuf.UnmanagedObject, intPtr1)
            resBuf.Dispose()

            If intStat <> CInt(Autodesk.AutoCAD.EditorInput.PromptStatus.OK) Then
                Throw (New System.Exception("Something wrong"))
                Return myLispArgs
            End If
        End If



        Dim rbfResult As ResultBuffer = New ResultBuffer(New TypedValue(LispDataType.Text, "called c:myFunction"))
        MsgBox("test1")

        Return rbfResult
    End Function


    <CommandMethod("testInvoke")> _
    Public Shared Sub testInvokeByCommand()

        MsgBox("test1")

        Dim resBuf As New Autodesk.AutoCAD.DatabaseServices.ResultBuffer()
        resBuf.Add(New TypedValue(LispDataType.Text, "c:myFunction")) 'name of the function
        resBuf.Add(New TypedValue(LispDataType.ListBegin, -1)) '" begin a list
        resBuf.Add(New TypedValue(LispDataType.Text, "Some TEXT added in VB function")) 'a double parameter
        resBuf.Add(New TypedValue(LispDataType.Text, "some more text")) ' value passed in
        resBuf.Add(New TypedValue(LispDataType.Double, 20.2)) 'a double parameter
        resBuf.Add(New TypedValue(LispDataType.ListEnd, -1)) 'end of the list 

        Dim intPtr1 As IntPtr = IntPtr.Zero
        Dim m_Return As Integer = acedInvoke(resBuf.UnmanagedObject, intPtr1)
        resBuf.Dispose()

        If m_Return <> CInt(Autodesk.AutoCAD.EditorInput.PromptStatus.OK) Then
            Throw (New System.Exception("Something wrong"))
        End If
        MsgBox("test2")
    End Sub
    'Use this lisp function to test the TestNoResbuf function
    '(defun lisptestnoresbuf (/ ename-some_ent)
    '  (setq ename-some_ent(car (entsel "\nselect something ")))
    '  (testnoresbuf ename-some_ent)
    '  )

    <LispFunction("testnoresbuf")> _
    Public Function TestNoResBuf(ByVal t1 As Object) As ObjectId
        MsgBox(t1.GetType.ToString())
        MsgBox(t1.ToString())

        Dim rb1 As ResultBuffer
        rb1 = t1


        Dim objID As ObjectId = rb1.AsArray(0).Value 'New ObjectId()
        Return objID
    End Function

    <LispFunction("ChangeVPSettings")> _
    Public Shared Function vpSettings(ByVal myLispArgs As ResultBuffer) As ResultBuffer

        Dim rbfResult As ResultBuffer
        Dim db As Database = HostApplicationServices.WorkingDatabase
        Dim tm As Transaction = db.TransactionManager.StartTransaction
        Try
            Dim myArgs As TypedValue() = myLispArgs.AsArray()
            If myArgs.Length < 3 Or myArgs.Length > 4 Then
                ' Return do not have the correct number of arguments
                rbfResult = New ResultBuffer( _
                            New TypedValue(CInt(5005), "Need to pass 3 or 4 arguments to ChangeVPSettings"))
                tm.Abort()
                Return rbfResult
            End If
            ' Get the ObjectId passed in from LISP function
            Dim vpID As ObjectId
            ' Ensure that an ObjectId was passed in
            If myArgs(0).TypeCode = LispDataType.ObjectId Then
                ' Ensure that a Viewport was selected by the user    
                Dim dbObj As DBObject
                Dim objID As ObjectId = myArgs(0).Value
                dbObj = tm.GetObject(objID, OpenMode.ForRead)
                If TypeOf dbObj Is Viewport Then
                    vpID = myArgs(0).Value
                Else
                    ' Return do not have a Viewport
                    rbfResult = New ResultBuffer( _
                                New TypedValue(CInt(5005), "Selected entity not A ViewPort"))
                    tm.Abort()
                    Return rbfResult
                End If
            Else
                ' Return, did not have an ObjectId
                rbfResult = New ResultBuffer( _
                                            New TypedValue(CInt(5005), "Problem with Argument 1 - Need ObjectID for viewport"))
                tm.Abort()
                Return rbfResult
            End If

            ' Get the color or Linetype to use for the layer viewport override from 3rd parameter
            Dim vpColorOverride As Int16
            Dim vpLineTypeOverride As String
            Dim ltObjID As ObjectId
            Dim bHaveLayerColor As Boolean = False
            Dim bHaveLineType As Boolean = False

            If myArgs(2).TypeCode = LispDataType.Int16 Then
                vpColorOverride = myArgs(2).Value
                bHaveLayerColor = True
                'ensure that color is less then 256
                If vpColorOverride > 255 Then
                    ' Return, Integer is too large for color index
                    rbfResult = New ResultBuffer( _
                                                New TypedValue(CInt(5005), "Color number for override needs to be less then 256"))
                    tm.Abort()
                    Return rbfResult
                End If
            Else
                If myArgs(2).TypeCode = LispDataType.Text Then
                    vpLineTypeOverride = myArgs(2).Value
                    'Ensure that the linetype is avialable
                    Dim lineTypeTable As LinetypeTable = CType(tm.GetObject(db.LinetypeTableId, OpenMode.ForRead, False), LinetypeTable)
                    Dim LineTypeExist As System.Boolean = lineTypeTable.Has(vpLineTypeOverride)
                    If LineTypeExist = False Then
                        rbfResult = New ResultBuffer( _
                                              New TypedValue(CInt(5005), vpLineTypeOverride & " linetype is unavailable"))
                        tm.Abort()
                        Return rbfResult
                    Else ' Get the ObjectId of the linetype

                        Dim lineType As LinetypeTableRecord
                        lineType = CType(tm.GetObject(lineTypeTable(vpLineTypeOverride), OpenMode.ForRead), LinetypeTableRecord)
                        ltObjID = lineType.ObjectId
                        bHaveLineType = True
                    End If
                Else
                    ' Return, args(2) does not contain valid value for color or linetype name
                    rbfResult = New ResultBuffer( _
                                                New TypedValue(CInt(5005), "Problem with value for argument 3 (color or Linetype)"))
                    tm.Abort()
                    Return rbfResult
                End If
            End If

            ' Get the color or Linetype to use for the layer viewport override from 4th parameter
            If myArgs.Length = 4 Then
                If myArgs(3).TypeCode = LispDataType.Int16 Then
                    vpColorOverride = myArgs(3).Value
                    bHaveLayerColor = True
                    'ensure that color is less then 256
                    If vpColorOverride > 255 Then
                        ' Return, Integer is too large for color index
                        rbfResult = New ResultBuffer( _
                                                    New TypedValue(CInt(5005), "Color number for override needs to be less then 256"))
                        tm.Abort()
                        Return rbfResult
                    End If
                Else
                    If myArgs(3).TypeCode = LispDataType.Text Then
                        vpLineTypeOverride = myArgs(3).Value
                        'Ensure that the linetype is avialable
                        Dim lineTypeTable As LinetypeTable = CType(tm.GetObject(db.LinetypeTableId, OpenMode.ForRead, False), LinetypeTable)
                        Dim LineTypeExist As System.Boolean = lineTypeTable.Has(vpLineTypeOverride)
                        If LineTypeExist = False Then
                            rbfResult = New ResultBuffer( _
                                                  New TypedValue(CInt(5005), vpLineTypeOverride & " linetype is unavailable"))
                            tm.Abort()
                            Return rbfResult
                        Else ' Get the ObjectId of the linetype

                            Dim lineType As LinetypeTableRecord
                            lineType = CType(tm.GetObject(lineTypeTable(vpLineTypeOverride), OpenMode.ForRead), LinetypeTableRecord)
                            ltObjID = lineType.ObjectId
                            bHaveLineType = True
                        End If
                    Else
                        ' Return, args(4) does not contain a valid value for color or linetype name
                        rbfResult = New ResultBuffer( _
                                                    New TypedValue(CInt(5005), "Problem with value for argument 4 (color or Linetype)"))
                        tm.Abort()
                        Return rbfResult
                    End If
                End If
            End If
            ' Ensure that args array (1) contains text - layer name
            If myArgs(1).TypeCode = LispDataType.Text Then
                Dim layerName As String
                layerName = myArgs(1).Value
                Dim lt As LayerTable = CType(tm.GetObject(db.LayerTableId, OpenMode.ForWrite, False), LayerTable)
                Dim layerExist As System.Boolean = lt.Has(layerName)

                ' Ensure that the layer exists
                If layerExist = False Then
                    tm.Abort()
                    rbfResult = New ResultBuffer( _
                               New TypedValue(CInt(5005), "Layer " & layerName & " does not exist"))

                    Return rbfResult
                    'End If
                Else
                    System.Diagnostics.Debug.Write("Changing Viewport overrides for testLayer ")
                    Dim layTblRec As LayerTableRecord
                    layTblRec = CType(tm.GetObject(lt(layerName), OpenMode.ForWrite), LayerTableRecord)

                    Dim lyVPprops As LayerViewportProperties
                    lyVPprops = layTblRec.GetViewportOverrides(vpID)
                    If bHaveLayerColor Then
                        lyVPprops.Color = Color.FromColorIndex(ColorMethod.ByAci, vpColorOverride)
                    End If
                    If bHaveLineType Then
                        lyVPprops.LinetypeObjectId = ltObjID
                    End If

                    'This works if this is the ActiveViewport
                    'Dim ed As Editor = Application.DocumentManager.MdiActiveDocument.Editor
                    'ed.SwitchToModelSpace()
                    'ed.Regen()
                    'ed.SwitchToPaperSpace()

                    ' This is not updating the display
                    'Dim vPort As Viewport
                    'vPort = tm.GetObject(vpID, OpenMode.ForWrite)
                    'vPort.UpdateDisplay()
                    'vPort.Visible = False
                    'vPort.Visible = True

                    ' this will update the display
                    'Autodesk.AutoCAD.ApplicationServices.Application.DocumentManager.MdiActiveDocument.SendStringToExecute("Regenall ", True, False, False)

                    tm.Commit()
                    rbfResult = New ResultBuffer( _
                           New TypedValue(CInt(5005), "Changed VP color override"))
                    Return rbfResult
                End If
            Else ' Args(2).Typecode was not LispDataType.Text
                tm.Abort()
                rbfResult = New ResultBuffer( _
                       New TypedValue(CInt(5005), "Problem with 2nd agrument - need text for the layer name"))
                Return rbfResult
            End If
        Catch ex As System.Exception
            System.Diagnostics.Debug.Write(ex.ToString())
        Finally
            tm.Dispose()
        End Try

        Return myLispArgs

    End Function
    <LispFunction("ChangeVPScale")> _
    Public Shared Function changeVPScale(ByVal myLispArgs As ResultBuffer) As ResultBuffer
        Dim rbfResult As ResultBuffer
        Dim db As Database = HostApplicationServices.WorkingDatabase
        Dim tm As Transaction = db.TransactionManager.StartTransaction

        Try
            Dim ed As Editor = Autodesk.AutoCAD.ApplicationServices.Application.DocumentManager.MdiActiveDocument.Editor
            If myLispArgs Is Nothing Then
                ' Write a message on the AutoCAD command line
                ed.WriteMessage("No Arguments passed in" & vbLf)
                Return myLispArgs
            Else
                Dim myArgs As TypedValue() = myLispArgs.AsArray()
                ' Ensure that an ObjectId was passed in
                If myArgs(0).TypeCode = LispDataType.ObjectId Then
                    ' Ensure that a Viewport was selected by the user    
                    Dim dbObj As DBObject
                    Dim objID As ObjectId = myArgs(0).Value
                    dbObj = tm.GetObject(objID, OpenMode.ForWrite)
                    If TypeOf dbObj Is Viewport Then
                        Dim viewPrt As Viewport
                        viewPrt = CType(dbObj, Viewport)

                        If myArgs(1).TypeCode = LispDataType.Text Then

                            Dim contextManager As ObjectContextManager = db.ObjectContextManager
                            If contextManager <> Nothing Then
                                'now get the Annotation Scaling context collection (named ACDB_ANNOTATIONSCALES_COLLECTION)
                                Dim contextCollection As ObjectContextCollection = contextManager.GetContextCollection("ACDB_ANNOTATIONSCALES")
                                ' 
                                If contextCollection <> Nothing Then
                                    Dim objCol As ObjectContext
                                    For Each objCol In contextCollection
                                        If objCol.Name = myArgs(1).Value Then
                                            ed.WriteMessage(objCol.Name.ToString())

                                            viewPrt.AnnotationScale = objCol

                                            tm.Commit()
                                            rbfResult = New ResultBuffer( _
                                                        New TypedValue(CInt(5005), "Changed the Annotation scale of the ViewPort"))
                                            Return rbfResult
                                            Exit For
                                        End If
                                    Next

                                    ' create a brand new scale context
                                    'Dim annoScale As AnnotationScale = New AnnotationScale()
                                    'annoScale.Name = "WBScale2 1:28"
                                    'annoScale.PaperUnits = 1
                                    'annoScale.DrawingUnits = 28
                                    ''now add to the drawing's context collection
                                    'contextCollection.AddContext(annoScale)
                                Else
                                    tm.Abort()
                                    rbfResult = New ResultBuffer( _
                                    New TypedValue(CInt(5005), "Problem getting scale collection"))
                                    Return rbfResult
                                End If
                            End If
                        Else
                            rbfResult = New ResultBuffer( _
                                        New TypedValue(CInt(5005), "second argument not text"))
                            Return rbfResult
                        End If
                    Else
                        ' Return do not have a Viewport
                        rbfResult = New ResultBuffer( _
                                    New TypedValue(CInt(5005), "Selected entity not A ViewPort"))
                        tm.Abort()
                        Return rbfResult
                    End If
                Else
                    ' Return do not have a Viewport
                    rbfResult = New ResultBuffer( _
                                New TypedValue(CInt(LispDataType.Text), "Argument passed in not an ObjectId"))
                    tm.Abort()
                    Return rbfResult
                End If


            End If
        Catch ex As System.Exception
            System.Diagnostics.Debug.Write(ex.ToString())

        Finally
            tm.Dispose()
        End Try


    End Function

End Class
